{
Searching for Files
Stop. This is the one and only solution to file searching. Use Delphi to find any file in any directory and/or subdirectory that match a certain mask. Start searching.

Article:
. http://delphi.about.com/library/weekly/aa051600a.htm

********************************************
Zarko Gajic
About.com Guide to Delphi Programming
http://delphi.about.com
email: delphi.guide@about.com
********************************************
}
unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, FileCtrl, PBFolderDialog, DBCtrls, Db, DBTables;

type
  TfrmMain = class(TForm)
    CheckBox1: TCheckBox;
    EdtMascara: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    SaveDialog1: TSaveDialog;
    chkMostrar: TCheckBox;
    chkGravar: TCheckBox;
    btnSearch: TSpeedButton;
    BtnFechar: TSpeedButton;
    PBFolderDialog1: TPBFolderDialog;
    chkRota: TCheckBox;
    chkTamanho: TCheckBox;
    chkData: TCheckBox;
    chkNomeAl: TCheckBox;
    chkNome: TCheckBox;
    DriveComboBox1: TDriveComboBox;
    dblCD: TDBLookupComboBox;
    Label3: TLabel;
    qryCD: TQuery;
    dtsCD: TDataSource;
    tblArquivos: TTable;
    tblArquivosArqCod: TAutoIncField;
    tblArquivosCdcod: TFloatField;
    tblArquivosArqNome: TStringField;
    tblArquivosArqTamanho: TFloatField;
    procedure btnSearchClick(Sender: TObject);
    procedure BtnFecharClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    procedure FileSearch(const PathName, FileName : string; const InDir : boolean);
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  Txt : TextFile;
  arquivos : integer ;

implementation
{$R *.DFM}
uses uFileInfo;


procedure TfrmMain.FileSearch(const PathName, FileName : string; const InDir : boolean);
var Rec  : TSearchRec;
    Path : string;
    dados_Arquivo : string;
begin
Path := IncludeTrailingBackslash(PathName);
if FindFirst(Path + FileName, faAnyFile - faDirectory, Rec) = 0 then

 try
   repeat
     dados_Arquivo :='';
    tblArquivos.Append ;
    tblArquivosCdcod.AsString      := dblCD.Text ;
    tblArquivosArqNome.AsString    := Rec.Name ;
    tblArquivosArqTamanho.Asfloat  := Rec.Size ;
    tblArquivos.Post ;
    arquivos := arquivos + 1;
   until FindNext(Rec) <> 0;
 finally
   FindClose(Rec);

 end;

If not InDir then Exit;

if FindFirst(Path + '*.*', faDirectory, Rec) = 0 then
 try
   repeat
   if (Rec.Attr in [faDirectory]) and (Rec.Name<>'.') and (Rec.Name<>'..') then
     FileSearch(Path + Rec.Name, FileName, True);
   until FindNext(Rec) <> 0;
 finally
   FindClose(Rec);
 end;
end; //procedure FileSearch

procedure TfrmMain.btnSearchClick(Sender: TObject);
begin
  if dblCD.KeyValue = null then begin
    showmessage('Informe o nmero do CD');
    exit;
  end;
  tblArquivos.Open ;
  arquivos := 0;
  FileSearch(DriveComboBox1.Drive+':', EdtMascara.Text, CheckBox1.State in [cbChecked]);
  tblArquivos.Close ;
  showmessage('Total de arquivos '+  inttostr(arquivos));
end;

procedure TfrmMain.BtnFecharClick(Sender: TObject);
begin
  close ;
end;

procedure TfrmMain.FormActivate(Sender: TObject);
begin
  qryCD.Open ;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  qryCD.Close ;
end;

end.
